
from XMLRPCServer import XMLRPCServer
from GUIEvents import sendGUIEvent
from qt import *
import threading

from configFile import KBlackBoardConfig


class rpcServer:
	def __init__( self, fileslist ) :
		
		self.fileslist = fileslist
		self.clientID = None
		
		self.server = XMLRPCServer(("", KBlackBoardConfig.getint('Client','CallbackPort')))
	
		for function in dir( self ) :
			if function.startswith( "rpc" ) :
				self.server.register_function( getattr( self , function ) )
		
		
		self.server.register_introspection_functions()
		
	def start( self ) :
		self.stopevent = threading.Event()
		self.thread = threading.Thread( target = self.serve_forever )
		self.thread.start()
	
	def stop( self ) :
		self.stopevent.set()
		self.thread.join()
	
	def serve_forever( self ):
		self.server.socket.settimeout( 1.0 )
		
		while not self.stopevent.isSet() :
			self.server.handle_request()
	
	def rpcSendFile( self, dict ):
		sendGUIEvent( self.fileslist.addFile,[],{ 'dict' : dict } )
	
	def rpcNotify( self, info ):
		sendGUIEvent( QMessageBox.information,
			[ None,
			"KBlackBoard",
			info,
			QMessageBox.Ok | QMessageBox.Default,
			0, 0 ] )
	
	def rpcDisconnect( self ):
		sendGUIEvent( QMessageBox.critical,
			[ None,
			"KBlackBoard",
			self.__tr("Server forced a disconnect"),
			QMessageBox.Ok | QMessageBox.Default,
			0, 0 ] )
	
	def __tr(self,s,c = None):
		return qApp.translate("frmMain",s,c)
