
import xmlrpclib, socket, re

class clientObject :
	def __init__( self, parent, name, address, port ):
		self.parent = parent
		self.name = parent.getUniqueName( name )
		self.callback = xmlrpclib.Server("http://%s:%d" % (address,port), allow_none = True)
		self.address = socket.gethostbyname( address )
		self.clientID = id( self )
		self.text = str( address ) + " " + str( name )
		
		self.parent.lst.insertItem( self.text )
	
	def validClient( self, address, clientID ):
		return self.address == socket.gethostbyname( address ) and self.clientID == clientID
	
	def __del__( self ):
		self.parent.lst.removeItem( self.index() )
	
	def index( self ):
		item = self.parent.lst.findItem( self.text )
		return self.parent.lst.index( item )
	
	def sendFile( self ):
		idx = self.parent.fileslist.lst.currentItem()
		f = self.parent.fileslist.getFile( idx )
		dict = f.saveState()
		self.callback.rpcSendFile( dict )


class clientsList :
	def __init__( self, lstClients, fileslist ):
		self.lst = lstClients
		self.fileslist = fileslist
		self.clients = []
	
	def addClient( self, **kwargs ):
		i = clientObject( self, **kwargs )
		self.clients.append( i )
		return i
	
	def getClient( self, idx, address = None ) :
		
		'''Get client by list index, or if optional address is specified, by clientID and address'''
		
		if address :
			for client in self.clients:
				if client.validClient( address, idx ):
					return client
		else:
			for client in self.clients :
				if self.lst.text(idx) == client.text :
					return client

	
	def getUniqueName( self, name ):
		
		'''Recursive function to find unique name for client by appending (2) etc.'''
		
		if name in map( lambda o : o.name , self.clients ) :
			r = re.findall('([^\(]*) \(([0-9])\)' , name)
			
			if len(r) == 0 :
				return self.getUniqueName( name + " (2)" )
			else :
				base = r[0][0]
				number = int(r[0][1]) + 1
				return self.getUniqueName( base + " (%d)" % number )
		else :
			return name
	
	def disconnect_all( self, reason = None ):
		for client in self.clients :
			self.remove( client , reason )
	
	def remove( self, item, reason = None ):
		if reason :
			item.callback.rpcNotify( reason )
		item.callback.rpcDisconnect()
		self.clients.remove( item )
	