
import re,os,tempfile,thread,datetime,base64,cPickle,traceback
from qt import *

from configFile import KBlackBoardConfig


class fileObject( object ):
	def __init__( self, parent, program = None, name = None, data = None, dict = None ):
		
		if not dict:
			if not name :
				name = str(self.__tr('New file'))
			
			self.data = data
			self.parent = parent
			self.log = ""
			self.program = program
			self.extension = ""
			
		else:
			if dict['ENCdata']:
				self.data = base64.b64decode( dict['ENCdata'] )
			else:
				self.data = None
			self.parent = parent
			self.log = dict['log']
			self.program = dict['program']
			self.extension = dict['extension']
			name = dict['name']
			
			
		self.__name = self.parent.getUniqueName( name )
		self.parent.lst.insertItem( self.__name )
			
		
	def __del__( self ):
		idx = self.index()
		self.parent.lst.removeItem( idx )
	
	def __setname( self, name ):
		name = self.parent.getUniqueName( name )
		
		self.logevent( str(self.__tr("Changed name to %s")) % name )
		
		idx = self.index()
		self.parent.lst.changeItem( name , idx )
		self.__name = name
	
	def __getname( self ):
		return str( self.__name )
	
	name = property( fget = __getname , fset = __setname )
	
	def index( self ):
		return self.parent.lst.index( self.parent.lst.findItem( self.__name ) )
	
	def logevent( self, info ):
		time = datetime.datetime.today()
		time = time.replace( microsecond = 0 )
		self.log += time.isoformat(" ") + " " + str(info)
	
	def view( self ):
		if not self.data :
			QMessageBox.critical( None,
				"KBlackBoard",
				self.__tr("File is empty!"),
				QMessageBox.Ok,
				0,0 )
		else :
			fd, n = tempfile.mkstemp( self.extension, self.name )
			
			f = open( n , 'w' )
			f.write( self.data )
			f.close()
		
			os.system( KBlackBoardConfig.get('Common','Viewer') % n )
		
			# os.remove( n ) FIXME

	def printer( self ):
		if not self.data :
			QMessageBox.critical( None,
				"KBlackBoard",
				self.__tr("File is empty!"),
				QMessageBox.Ok,
				0,0 )
		else :
			fd, n = tempfile.mkstemp( self.extension, self.name )
			
			f = open( n , 'w+b' )
			f.write( self.data )
			f.close()
			
			os.system( KBlackBoardConfig.get('Common','Printer') % n )
			
			os.remove( n )
			
	
	def edit( self ):
		
		d = None
		
		if not self.data :
			d = tempfile.mkdtemp( "", self.name )
			QMessageBox.information( None,
				"KBlackBoard",
				str( self.__tr("Save to folder %s.")) % d,
				QMessageBox.Ok,
				0,0 )
			
			os.system( "cd '%s' ; '%s'" % (d , self.program) )
			
			files = os.listdir( d )
			
			for backupfile in filter( lambda s : s.endswith('~') , files ) :
				#Remove backupfiles that end in ~
				os.remove( os.path.join( d , backupfile ) )
			
			files = filter( lambda s : not s.endswith('~') , files )
			if len( files ) != 1 :
				v = QMessageBox.warning( None,
					"KBlackBoard",
					self.__tr("Could not automatically locate file. Choose it manually?"),
					QMessageBox.Yes | QMessageBox.Default,
					QMessageBox.No | QMessageBox.Escape )
				
				if v == QMessageBox.Yes :
					n = str( QFileDialog.getOpenFileName( d,
						self.__tr("All files (*)"),
						None ) )
				else :
					return
			else :
				n = os.path.join( d , files[0] )
			
			self.extension = os.path.splitext( n )[1]
			
			self.logevent( str( self.__tr('Created with %s') ) % self.program )
			
		else :
			fd, n = tempfile.mkstemp( self.extension, self.name )
			
			f = open( n , 'wb' )
			f.write( self.data )
			f.close()
			
			os.system( KBlackBoardConfig.get('Common','Editor') % n )
			
			QMessageBox.information( None,
				"KBlackBoard",
				self.__tr("Press ok when done editing."),
				QMessageBox.Ok,
				0,0 )
			
		
		f = open( n , 'rb' )
		self.data = f.read()
		f.close()
		
		os.remove( n )
		
		if d :
			os.rmdir( d )
	
	def saveState(self):
		'''Return dict representing file's information'''
		d = {}
		if self.data :
			d['ENCdata'] = base64.b64encode( self.data )
		else :
			d['ENCdata'] = None
		
		d['name'] = self.__name
		d['program'] = self.program
		d['extension'] = self.extension
		d['log'] = self.log
		return d
	
	def __tr(self,s,c = None):
		return qApp.translate("frmMain",s,c)
	
	
	
class filesList:
	def __init__( self, lstFiles ):
		self.lst = lstFiles
		self.files = []
	
	def addFile( self, **kwargs ) :
		
		'''Add file to list'''
		
		i = fileObject( self , **kwargs )
		self.files.append( i )
		return i
	
	def getFile( self, idx ) :
		
		'''Get fileObject from list index'''
		
		for file in self.files :
			if self.lst.text(idx) == file.name : return file
	
	def getUniqueName( self, name ):
		
		'''Recursive function to find unique name for file by appending (2) etc.'''
		
		if name in map( lambda o : o.name , self.files ) :
			r = re.findall('([^\(]*) \(([0-9])\)' , name)
			
			if len(r) == 0 :
				return self.getUniqueName( name + " (2)" )
			else :
				base = r[0][0]
				number = int(r[0][1]) + 1
				return self.getUniqueName( base + " (%d)" % number )
		else :
			return name
	
	def clear( self ):
		self.files = [] #Garbage collection should remove items from listbox
	
	def remove( self, item ):
		self.files.remove( item )
	
	def loadFile( self, file, **kwargs ):
		
		'''Load file from file and add to list'''
		
		if isinstance( file, str ): file = open( file, 'rb' )
		
		data = file.read()
		self.addFile( data = data , **kwargs )
		
	
	def saveList( self, file ):
		
		'''Save all files and list information to file'''
		
		if isinstance( file, str ): file = open( file, 'w' )
		
		data = []
		
		for f in self.files :
			data.append( f.saveState() )
		
		cPickle.dump( data , file )
	
	def loadList( self, file ):
		
		'''Append files from saved list'''
		try :
			if isinstance( file, str ): file = open( file, 'r' )
			
			data = cPickle.load( file )
			
			for d in data :
				self.addFile( dict = d )
		except:
			traceback.print_exc()
			QMessageBox.critical( None,
					"KBlackBoard",
					str(self.__tr("Could not open file '%s'. Possibly it is not a KBlackBoard list file?")) % file.name,
					QMessageBox.Ok | QMessageBox.Default,
					0,0 )
	
	def __tr(self,s,c = None):
		return qApp.translate("frmMain",s,c)