
from XMLRPCServer import XMLRPCServer
from GUIEvents import sendGUIEvent
import threading

from configFile import KBlackBoardConfig


class rpcServer:
	def __init__( self, fileslist, clientslist ) :
		
		self.fileslist = fileslist
		self.clientslist = clientslist
		
		self.server = XMLRPCServer(("", KBlackBoardConfig.getint('Common','Port')))
	
		for function in dir( self ) :
			if function.startswith( "rpc" ) :
				self.server.register_function( getattr( self , function ) )
		
		
		self.server.register_introspection_functions()
		
	def start( self ) :
		self.stopevent = threading.Event()
		self.thread = threading.Thread( target = self.serve_forever )
		self.thread.start()
	
	def stop( self ) :
		try:
			self.clientslist.disconnect_all() 
		except:
			pass
		self.stopevent.set()
		self.thread.join()
	
	def serve_forever( self ):
		self.server.socket.settimeout( 1.0 )
		
		while not self.stopevent.isSet() :
			self.server.handle_request()
	
	def rpcSendFile( self, dict ):
		sendGUIEvent( self.fileslist.addFile,[],{ 'dict' : dict } )
	
	def rpcRegisterClient( self, name, port, clientAddr = None ) :
		c = sendGUIEvent( self.clientslist.addClient, [], { 'name' : name, 'address' : clientAddr, 'port' : port } )
		return c.clientID
	
	def rpcConfig( self ):
		return KBlackBoardConfig
	
	def rpcServerInfo( self ) :
		return KBlackBoardConfig.get('Server','Description')
